#ifndef ___TIME_H___
#define ___TIME_H___

#include <chrono>


#include "Object.h"
#include "ObjectParser.h"
#include "misc.h"
#include "_strTimelog.hpp"

namespace FD {

class Time : public Object {
public:
  std::chrono::system_clock::time_point time;

public:
  Time() {}
  Time(std::chrono::system_clock::time_point t) : time(t) {}

  void setTime(const std::chrono::system_clock::time_point& t) {
    time = t;
  }

  void setLocalTime() {
    time = std::chrono::system_clock::now();
  }


  virtual void printOn(std::ostream& out) const
  {
    out << "<Time <time " << _TimeLog(time) << "> >";
  }

  void readFrom(std::istream &in)
  {
  }
  
  friend std::istream& operator>>(std::istream &in, Time& src);
};

inline std::istream& operator>>(std::istream &in, Time& src)
{
    if (!isValidType(in, "Time")) {
        return in;
    }
    src.readFrom(in);
    return in;
}

}


#endif
