#pragma once

#ifndef ___STRTIMELOG_HPP___
#define ___STRTIMELOG_HPP___


#include <string>
#include <chrono>
#include <time.h>
#include <vector>
#include <sstream>
#include <iostream>
#include <iomanip>

using namespace std;

static std::string TimeLog(const std::chrono::system_clock::time_point& t){
   std::chrono::microseconds dus = std::chrono::duration_cast<std::chrono::microseconds>(t.time_since_epoch());
   std::chrono::seconds ds = std::chrono::duration_cast<std::chrono::seconds>(t.time_since_epoch());

   std::time_t timet = (time_t)ds.count();
   int us = dus.count() - ds.count() * 1e6;
   const tm* lt = std::localtime(&timet);

   string strLog;
   std::ostringstream sout;
   std::vector<std::string> strMonList ={"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

   sout << (lt->tm_year + 1900)
   		<< "-" << strMonList[lt->tm_mon]
   		<< "-" << std::setfill('0') << std::setw(2) << lt->tm_mday
   		<< " " << std::setfill('0') << std::setw(2) << lt->tm_hour
   		<< ":" << std::setfill('0') << std::setw(2) << lt->tm_min
   		<< ":" << std::setfill('0') << std::setw(2) << lt->tm_sec
   		<< "." << std::setfill('0') << std::setw(6) << us;

   strLog = sout.str();

   	return strLog;
}


#endif